##  Correlation manager configuration module 
##
package ADS3kp_conf;
use Exporter;

@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{

}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Read($$){
    my ($pkg, $fname) = @_;
    $pkg->{conf} = $fname;
    
    unless(open(IN,$fname)){
	print STDERR 
	    "Error in ADS3kp_conf::Read_conf(): Failed to open conf file $fname.\n";
	return -1;
    }
    my $mode =0;
    my (@hlist, @freq, @ifarr, @ulsb, $bw, $nfrq);
    my $icnt=0;
    while(<IN>){
	if(/\$BW\s+(\d+)/){  $bw =$1; next;}
	if(/\$FREQ\s+(\d+)/){ $nfrq =$1; $mode=2; next;}
	if(/\$MODE\s+(\d+)/){ $outmode =$1; $mode=3; next;}
	next if(/^\#/);
	if($mode==2){ ## Freq 
	    /^\s*/;
	    my @terms = split(/\s+/,$'); # ');
	    next if(@terms < 4 );
	    if($icnt != $terms[0]-1){
		printf "E Conf file, expecting ch= %d, but data= $_\n",$icnt +1;
		next;
	    }
	    $freq[$icnt] = $terms[1] * 1.e6; # MHz -> Hz
	    $ifarr[$icnt] = $terms[2];
	    if($terms[3] =~ /U/){
		$ulsb[$icnt] = 0;
	    }elsif($terms[3] =~/L/){
		$ulsb[$icnt] = 1;
	    }
	    $icnt++;
	    next;
	}
    }
    close(IN);
    
    if(defined($nfrq) && defined($bw) 
       && defined($freq[0]) && defined($ulsb[0])){
	$pkg->{nfrq} = $nfrq;
	$pkg->{frq} = \@freq;
	$pkg->{bw} = $bw;
	$pkg->{ifarr} = \@ifarr;
	$pkg->{ulsb} = \@ulsb;
	$pkg->{mode} = $outmode if(defined($outmode));
	return 0;
    }else{
	return -1;
    }
}


sub FreqArr($){
    my $pkg = shift;
    return  @{$pkg->{frq}};
}

sub BW($){
    my $pkg = shift;
    return  $pkg->{bw};
}

sub ULSBArr($){
    my $pkg = shift;
    return  @{$pkg->{ulsb}};
}

sub IFArr($){
    my $pkg = shift;
    return  @{$pkg->{ifarr}};
}

sub Mode($){
    my $pkg = shift;
    my $mode = $pkg->{mode};
    if(defined($mode)){
	return $mode;
    }else{
	return -1;
    }
}

1;
