#!/usr/bin/perl -w

## $Id: ads3kp_set2.pl 34 2014-07-17 00:03:21Z sekido $
## Updated on $Date: 2014-07-17 09:03:21 +0900 (Thu, 17 Jul 2014) $ by $Auther$
$rev = '$Rev: 34 $ updated on $Date: 2014-07-17 09:03:21 +0900 (Thu, 17 Jul 2014) $';

use lib "$ENV{HOME}/prog/perl/module";
use lib "/usr/local/share/ADS3kp";
use ADS3kp;
use ads3kp_conf;

# use Net::Telnet;
use Time::HiRes qw( usleep nanosleep );

sub usage(){
    print "Usage: $0 -c <conf file> -a <ads3k hostname/ipaddress>\n";
    print " Default hostname = 133.243.128.80\n";
    print " Version: $rev\n";
    exit 1;
}


{
    # ڑ(ɍ킹ďC)
    my $user = 'root';	# [U
#    my $pass = 'ksrc$34m';	# pX[h
    my $pass = 'redhat';	# pX[h
    #my $prompt = '/\[.+\]\$ $/';	# vvg(K\)
#    my $prompt = '/cosmo login:$|Password:$|\[.+\]\$ $/';# vvg(K\)

    my $conffile;
    my $host = "133.243.128.80";

    usage() if (@ARGV<1);
    my $ads = new ADS3kp;
    while(@ARGV){
	my $opt = shift;
	if($opt =~/-c/){
	    $conffile = shift;
	}elsif($opt =~/-a/){
	    $host = shift;
	    $ads->SetHost($host,$user,$pass);
	    print "Host = $host \n" ;
	}
    }
    
    if(defined($conffile)){
	print "Input file = $conffile. \n";
    }else{
	print STDERR "Error: Missing input file.\n";
	usage();
    }
    
    my $conf = new ADS3kp_conf;
    if($conf->Read($conffile) < 0){
	print "E Failed to read conf-file:$conffile \n";
	exit(1);
    }
    
    my $bw = $conf->BW();
    my @frq = $conf->FreqArr();
    my @ulsb = $conf->ULSBArr();
    my @ifin = $conf->IFArr();
    my $dbbc_mode = $conf->Mode();

    my @hfrq = $ads->CompFreq($conf);
    my @cfrq = $ads->CFrq();
    print "##CH  Freq ";
    for(my $i=0; $i < @hfrq; $i++){
	printf("%2d %s %.3f %d \n", $i, $hfrq[$i], $cfrq[$i], $ifin[$i]);
    }
    
    $ads->SetLo();
    $ads->SetBW($bw);
    $ads->SetIFin(@ifin);
    $ads->SetULSB(@ulsb);
    $ads->SetDBBC_Mode($dbbc_mode) if( $dbbc_mode > 0);

    ######
    print "### Current Settings are ########\n";
    my @frq_ret = $ads->ReadLo();
    my @bw_ret = $ads->ReadBW();
    for( $i=0; $i<@frq_ret; $i++){
	printf "%2d %7.6f MHz  %5.2f MHz\n", 
	$i, $frq_ret[$i]*1.e-6, $bw_ret[$i]*1.e-6;
    }

}

