#!/usr/bin/perl -w

#use Net::Telnet;

sub usage(){
    print "Usage: $0 [-out <outfile> -a <ads3k hostname/ipaddress>]\n";
    print " Default hostname = 133.243.59.56\n";
    print " Generating  config file for ads3kp_set2.pl \n";
    exit(1);
}

use lib "$ENV{HOME}/prog/perl/module";
use ADS3kp;

$ads = new ADS3kp;

{
	my $host = '133.243.59.56';
    my ($outfile);
    while(@ARGV){
		my $opt = shift;
		if($opt =~/-out/){
		    $outfile = shift;
		}elsif($opt =~/-a/){
	    	$host = shift;
	    print $host;
		}	    
    }
    
    usage() unless(defined($outfile));
    
	$usr = 'root'; 
	$pass = 'redhat'; 

	my $login_chk = $ads->SetHost2($host,$usr,$pass);
	if ( $login_chk eq -1 ){
		print "Failed to Connecting to the Host\n";
		return;
	}
    open(OUT,">$outfile") || die "Cannot open Outfile($outfile)\n";

	print OUT "#1pps_sync\n";
	print OUT "1pps_sync\n\n";

	print OUT "# offs ch [0x00-0xFF]\n";
    my @offs = $ads->ReadOffs();
    for(my $i=0; $i<@offs; $i++){
		$offs[$i]=~ s/\s+//g;
		$offs[$i]=sprintf("0x%0x",$offs[$i]);
		my $cnt=$i+1;
		print OUT "offs $cnt $offs[$i]\n";
    }
	print OUT "\n";
	
	#my $msg = sprintf "#offs ch 0x00-0xFF\n",$ads->ReadAdcoffs();
	#$temp = sprintf("0X%0X", $offs[$i]);
	
	print OUT "# gain ch [0-7; 2^NUM]\n";	
    my @gain = $ads->ReadGain();
    for(my $i=0; $i<@gain; $i++){
		$gain[$i]=~ s/\s+//g;
		my $cnt=$i+1;
		print OUT "gain $cnt $gain[$i]\n";
    }
	print OUT "\n";
	
	my @cicgain = $ads->ReadCicgain();
	print OUT "# Input cicgain settting [0->1, 1->2, 2->4, 3->8] \n";
	print OUT "cicgain ";
	#@cicgain = grep { !/^\s*$/ } @cicgain;
	#@cicgain = map {$_ =~ s/^\s*(.*?)\s*$/$1/;$_} @cicgain;
    for(my $i=0; $i<@cicgain; $i++){
		$cicgain[$i]=~ s/\s+//g;
		print OUT "$cicgain[$i]";
    }	
	print OUT "\n\n";
	
	my @bbcgain = $ads->ReadBbcgain();
	print OUT "# Input bbcgain settting [-6~+6dB] \n";
	print OUT "# [7:+7dB=>7],[6:+6dB=>6],[5:+5dB=>5],[4:+4dB=>4],[3:+3dB=>3],[2:+2dB=>2],[1:+1dB=>1],[0:0dB=>0], \n";
	print OUT "# [F:-1dB=>F],[E:-2dB=>E],[D:-3dB=>D],[C:-4dB=>C],[B:-5dB=>B],[A:-6dB=>A],[9:-6dB=>9],[8:-6dB=>8] \n";
	print OUT "bbcgain ";
    for(my $i=0; $i<@bbcgain; $i++){
		$bbcgain[$i]=~ s/\s+//g;
		print OUT "$bbcgain[$i]";
    }	
	print OUT "\n\n";
	
	my @adcoffs = $ads->ReadAdcoffs();
	print OUT "# Input adcoffs settting [0x00-0xFF] \n";
	#@adcoffs=sprintf("0x%0x",@adcoffs);
	print OUT "adcoffs @adcoffs\n";
	print OUT "\n";
	
	my @adcgain = $ads->ReadAdcgain();
	print OUT "# Input adcgain settting [0x00-0xFF] \n";
	#@adcgain=sprintf("0x%0x",@adcgain);
	print OUT "adcgain @adcgain\n";



    close(OUT);
    
}

