using namespace std;

void gaussian_fitting(double* x,double* y, unsigned int size, double& variance,
		      double&  average, double &Amp){

	double X=0,XX=0,XXX=0,XXXX=0,Y=0,YX=0,YXX=0;

	for(unsigned int i = 0 ; i<size ; i++){
	  X += x[i];
	  XX += (x[i]*x[i]);
	  XXX += (x[i]*x[i]*x[i]);
	  XXXX += (x[i]*x[i]*x[i]*x[i]);
	  Y += y[i];
	  YX += (y[i]*x[i]);
	  YXX += (y[i]*x[i]*x[i]);
	}//for
	X    /= size;
	XX   /= size;
	XXX  /= size;
	XXXX /= size;
	Y    /= size;	
	YX   /= size;
	YXX  /= size;
	
	double a,b,c;
	a=( (Y*XX-YXX)*(X*X-XX)-(Y*X-YX)*(X*XX-XXX) )/
	  ( (XX*XX-XXXX)*(X*X-XX)-(XX*X-XXX)*(XX*X-XXX) );
	b=(Y*X-YX-a*(XX*X-XXX))/(X*X-XX);
	c=Y-a*XX-b*X;
	variance = 1/(-2*a);
	average = b/(-2*a);
	Amp = exp(c - b*b/a * 0.25);
}//gaussian_fitting
