#!/usr/bin/perl -w

sub usage(){
    print "Usage: $0 [-skd <skd file>] [-stid <stid>] [-out <outfile>]\n";
    print " Generating  config file for ads3kp_set.pl \n";
    print "-stid: Station ID: default='O'. \n";
    exit(1);
}

use lib "$ENV{HOME}/prog/perl/module";

use Sched_db;


{
    my ($skdfile,$stid,$outfile);
    $stid = "O";
    while(@ARGV){
	my $opt = shift;
	if($opt =~/-skd/){
	    $skdfile = shift;
	}elsif($opt =~/-stid/){
	    $stid = shift;
	}if($opt =~/-out/){
	    $outfile = shift;
	}	    
    }
    usage() unless(defined($skdfile) && defined($outfile));
    
    
    my $skddb = new Sched_db;
    $skddb->Read($skdfile);
    
    &Write_conf($skddb,$outfile,$stid);
    
}


sub Write_conf($$$){
    my $skddb = shift;
    my $outfile = shift;
    my $stid = shift;
    open(OUT,">$outfile") || die "Cannot open Outfile($outfile)\n";
    my $msg = sprintf "\$BW  %2d MHz\n\n",$skddb->BW();
    print OUT "$msg"; print "$msg";
    my @rf = $skddb->RFarr();
    my $nch = $skddb->Nch();
    $msg = sprintf  "\$FREQ %d \n", $nch;
    print OUT "$msg"; print "$msg";
    $msg = sprintf "#ch, Freq, IF(0-3),  U/LSB \n";
    print OUT "$msg"; print "$msg";
    my $i=0;

    my %ul =(-1,'L',1,'U');
    my %bid=('1N',0,'2N',2,'3N',1);

    my @lo = $skddb->LoChArr($stid);
    my @ulsb = $skddb->ULSB_ChArr($stid);
    
    
    my @iband = $skddb->IFnoChArr($stid);
    for($i=0; $i< $nch; $i++){
	my $imfrq = $rf[$i] - $lo[$i];
# 	if($imfrq < 0.0){
# 	    $imfrq *= -1 ;
# 	    $ulsb[$i] *= -1;
# 	}
	if($imfrq <0){$imfrq *= -1; $ulsb[$i] *= -1;}
	$msg = sprintf  "%2d  %8.2f %s %s",$i+1, $imfrq, 
	$bid{$iband[$i]}, $ul{$ulsb[$i]};
	print OUT "$msg\n"; 
	printf "$msg : %8.2f %7.2f\n", $rf[$i], $lo[$i];
    }
    print OUT "################## END ####\n";
    close(OUT);
    
}

