#!/usr/bin/perl -w
  
# $Id: tcp-sampl2.pl,v 1.2 2012/04/19 07:04:50 sekido Exp $

use IO::Socket;                   # IO::Socket モジュールを使う。

sub usage(){
    print "Usage: $0 [-h] [-a <hostname>] [-p <port>] \n";
    exit(1);
}


{
    # ホスト名とポート番号を設定
    my $host = 'localhost';
    my $port = getservbyname('echo','tcp') || 7;
    while(@ARGV){
	my $opt =shift;
	if($opt =~/-p/){
	    $port = shift;
	}elsif($opt =~/-a/){
	    $host = shift;
	}elsif($opt =~/-h/){
	   usage(); 
	}
    }

    
    print STDERR "$host:$port に接続します...";
    
    $socket = IO::Socket::INET->new(PeerAddr => $host,
                                    PeerPort => $port,
                                    Proto    => 'tcp',
                                    );
    select($socket); $|=1; # No buffering 
    my $sock_state = stat $socket;
#    print STDERR "Socket State= $sock_state \n";
    if ( ! $socket || $sock_state !=1){
        die "\n$host:$port に接続できませんでした。 $!\n";
    }
    print STDERR "Successed.\n";

    for (1..5){
	# 文字列を送信
        print STDOUT "送信メッセージ: line $_\n";
        print $socket "line $_\n";
        $socket->flush();
	
	# 文字列を受信
        $buf = <$socket>;
        print STDOUT "受信メッセージ: $buf";
    }
    
    $socket->close();
}
